<?php
/**
 * Created by PhpStorm.
 * User: crose
 * Date: 2/18/16
 * Time: 5:30 PM
 */

namespace qfq;

require_once(__DIR__ . '/../Constants.php');
require_once(__DIR__ . '/../exceptions/UserFormException.php');
require_once(__DIR__ . '/../helper/Support.php');

/**
 * Class Logger
 * @package qfq
 */
class Logger {

    /**
     * Haengt $msg an $filename an
     *
     * @param $msg
     * @param $filename
     *
     * @param string $mode
     * @throws UserFormException
     */
    public static function logMessage($msg, $filename, $mode = FILE_MODE_APPEND) {

        if ($filename == '') {
            return;
        }

        if (!$handle = fopen($filename, $mode)) {

            // If open fails, maybe die directory does not exist. Create it:
            Support::mkDirParent($filename);

            // Try to open the file a second time.
            if (!$handle = fopen($filename, $mode)) {
                throw new UserFormException("Error - cannot open. File: " . $filename . " ( CWD: " . getcwd() . ") - " . error_get_last(), ERROR_IO_OPEN);
            }
        }

        if (fwrite($handle, $msg . PHP_EOL) === false) {
            throw new UserFormException("Error - cannot write. File: " . $filename . " ( CWD: " . getcwd() . ") - " . error_get_last(), ERROR_IO_WRITE);
        }

        fclose($handle);
    }

    /**
     * @param array $fe
     *
     * @return string
     */
    public static function formatFormElementName(array $fe) {
        Support::setIfNotSet($fe, 'id');
        Support::setIfNotSet($fe, FE_NAME);
        Support::setIfNotSet($fe, FE_LABEL);

        return $fe['id'] . ' / ' . $fe[FE_NAME] . ' / ' . $fe[FE_LABEL];
    }
}